format compact;
path_logs='/scratch2/clear/mairal/large_datasets/logs_siam_revision/';
tabn=[581012 500000 2500000 72309 781265 250000];
tabdataset={'covtype','alpha','ocr','real-sim','rcv1','webspam'};
tabexperiment=1:8
tabrun=0;
tabepochs=[1 2 3 4 5 10 15 20 25 50];

selected=1:8;

% first find the highest dual value found for each experiment
all_optim=cell(3,length(tabdataset));;
all_times=cell(3,length(tabdataset));;
best_dual=-inf*ones(3,length(tabdataset));;
best_primal=inf*ones(3,length(tabdataset));;

run=0;
for jj=1:length(tabdataset)
   dataset=tabdataset{jj};
   n=tabn(jj);
   tablambda=[1/n 10/n 0.1/n];
   for ll=1:length(tablambda)
      lambda=tablambda(ll);
      for kk=1:length(tabexperiment)
         experiment=tabexperiment(kk)
         name=sprintf('%s/exp_logistic_l2_%s_%d_%d_%d.mat',path_logs,dataset,ll,experiment,run);
         name2=sprintf('%s/exp_dual_logistic_l2_%s_%d_%d_%d.mat',path_logs,dataset,ll,experiment,run);
         if exist(name)
            load(name);
            optims
            all_optim{ll,jj}=[all_optim{ll,jj}; optims];
            all_times{ll,jj}=[all_times{ll,jj};times];
            load(name2);
            best_dual(ll,jj)=[max([best_dual(ll,jj),max(dual)])];
            best_primal(ll,jj)=[min([best_primal(ll,jj),min(optims)])];
            times
         else
            all_optim{ll,jj}=[all_optim{ll,jj}; zeros(1,length(tabepochs))];
            all_times{ll,jj}=[all_times{ll,jj}; zeros(1,length(tabepochs))];
         end
      end
   end
end

mkdir('results');

name={'SGD-h','FISTA','SDCA','SAG','MISO0','MISO1','MISO2','MISO\mu'};
name2={'SGD-h','FISTA','SDCA','SAG','MISO0mb','MISO1mb','MISO2mb','MISO\mu'};
colors={'-^g','-dm','-sb','-*k','-xr','-or','-pr','-dr','-gx','-cx'};

clf;

for dataset=1:6
   for lambda=1:3
      dataset
      optim=all_optim{lambda,dataset};
      times=all_times{lambda,dataset};

      ind=find(optim);
      min_optim=best_dual(lambda,dataset); % find the highest dual value found by all methods
      optimm=max((optim-min_optim)/(abs(min_optim)),1e-10)'

      optim=optim(selected,:);
      times=times(selected,:);
      optimm=optimm(:,selected);
      clf;
      set(gcf,'position',[1000 500 400 250]);
      for kk=1:length(selected)
         semilogy(tabepochs,optimm(:,kk),colors{kk},'MarkerSize',10,'LineWidth',2); hold on;
         set(gca,'XTick',0:5:50);
         set(gca,'YTick',10.^(-10:2:1));
         set(gca,'YMinorTick','off'); 
         set(gca,'FontSize',12);
         xlabel(sprintf('Effective passes over data / Dataset %s',tabdataset{dataset}));
         ylabel('Relative duality gap');
         if dataset >= 4
            axis([0 50 1e-10 10]);
         else
            axis([0 50 1e-10 1]);
         end
         %         loglog((times(kk,:))',optimm(:,kk),colors{kk}); hold on;
      end
      if dataset==6
         legend(name2{selected});
      elseif dataset==3
         legend(name{selected});
      end
      set(gcf,'PaperPositionMode','Auto');
      print('-depsc2',sprintf('results/%s_l2_epochs_%d.eps',tabdataset{dataset},lambda));
   end
end

clf;
for dataset=1:6
   %subplot(2,3,dataset);
   for lambda=[1:3]
      dataset
      lambda
      tablambda(lambda)
      optim=all_optim{lambda,dataset};
      times=all_times{lambda,dataset};

      ind=find(optim);
      min_optim=best_dual(lambda,dataset);
      optimm=max((optim-min_optim)/((min_optim)),1e-10)'

      optim=optim(selected,:);
      times=times(selected,:);
      optimm=optimm(:,selected);
      clf;
      set(gcf,'position',[1000 500 400 250]);
      for kk=1:length(selected)
         %         semilogy(tabepochs,optimm(:,kk),colors{kk},'MarkerSize',10,'LineWidth',2); hold on;
         loglog((times(kk,:))',optimm(:,kk),colors{kk},'MarkerSize',10,'LineWidth',2); hold on;
         %set(gca,'XTick',0:5:50);
         set(gca,'YTick',10.^(-10:2:1));
         set(gca,'YMinorTick','off'); 
         set(gca,'XMinorTick','off'); 
         set(gca,'FontSize',12);
         xlabel(sprintf('Time in seconds / Dataset %s',tabdataset{dataset}));
         ylabel('Relative duality gap');
         %title(tabdatasets{dataset});
         if dataset == 1 || dataset==2
            axis([1e-1 1e2 1e-10 1]);
         elseif dataset==3
            axis([1e0 1e4 1e-10 1]);
         elseif dataset==4
            axis([1e-2 1e1 1e-10 10]);
         elseif dataset==5
            axis([1e-1 1e2 1e-10 10]);
         elseif dataset==6
            axis([10^(0.5) 1e4 1e-10 10]);
         end

      end
      if dataset==6
         legend(name2{selected});
      elseif dataset==3
         legend(name{selected});
      end
      set(gcf,'PaperPositionMode','Auto');
      print('-depsc2',sprintf('results/%s_l2_times_%d.eps',tabdataset{dataset},lambda));
   end
end
